#lang scheme
(provide test
         run-tests)

(define (check-test got expected expr)
  (unless (equal? got expected)
    (error 'test "failed: ~s produced ~e, expected ~e"
           expr
           got
           expected)))

(define thunks null)
(define (register! thunk)
  (set! thunks (cons thunk thunks)))
(define (run-tests)
  (for-each (lambda (thunk) (thunk)) 
            (reverse thunks))
  (set! thunks null))
         
(define-syntax-rule (test expr expected)
  (register! (lambda ()
               (check-test expr expected 'expr))))
